Index: /XIOS/trunk/src/filter/spatial_transform_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/spatial_transform_filter.cpp	(revision 1981)
+++ /XIOS/trunk/src/filter/spatial_transform_filter.cpp	(revision 1982)
@@ -331,4 +331,10 @@
       currentBuff = 0;
       bool firstPass=true; 
+      
+      if(filterID >=0) // building_graph
+      {
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[filterID].filter_name += ("\\n"+(*itAlgo)->getName());
+      } 
+        
       for (itRecv = itbRecv; itRecv != iteRecv; ++itRecv)
       {
@@ -336,8 +342,5 @@
         int srcRank = itRecv->first;
 
-        if(filterID >=0) // building_graph
-        {
-           (*CWorkflowGraph::mapFilters_ptr_with_info)[filterID].filter_name = (*itAlgo)->getName();
-        } 
+        
         if (srcRank != rank)
         {
Index: /XIOS/trunk/src/transformation/axis_algorithm_duplicate_scalar.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_duplicate_scalar.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/axis_algorithm_duplicate_scalar.hpp	(revision 1982)
@@ -33,5 +33,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Axis Trans. Filter \\n Duplicate Scalar";}
+  virtual StdString getName() {return "duplicate_scalar";}
 
 protected:
Index: /XIOS/trunk/src/transformation/axis_algorithm_extract.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_extract.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/axis_algorithm_extract.hpp	(revision 1982)
@@ -28,6 +28,6 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Axis Trans. Filter \\n Extract";}
-
+  virtual StdString getName() {return "extract_axis";}
+  
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: /XIOS/trunk/src/transformation/axis_algorithm_extract_domain.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_extract_domain.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/axis_algorithm_extract_domain.hpp	(revision 1982)
@@ -40,5 +40,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Axis Trans. Filter \\n Extract Domain";}
+  virtual StdString getName() {return "extract_domain";}
 
 protected:
Index: /XIOS/trunk/src/transformation/axis_algorithm_interpolate.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_interpolate.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/axis_algorithm_interpolate.hpp	(revision 1982)
@@ -33,5 +33,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Axis Trans. Filter \\n Interpolation";}
+  virtual StdString getName() {return "interpolate_axis";}
   bool isInversed() {return isInversed_;}
 
Index: /XIOS/trunk/src/transformation/axis_algorithm_inverse.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_inverse.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/axis_algorithm_inverse.hpp	(revision 1982)
@@ -31,5 +31,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Axis Trans. Filter \\n Inverse";}
+  virtual StdString getName() {return "inverse_axis";}
 
 protected:
Index: /XIOS/trunk/src/transformation/axis_algorithm_reduce_axis.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_reduce_axis.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/axis_algorithm_reduce_axis.hpp	(revision 1982)
@@ -40,5 +40,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Axis Trans. Filter \\n Reduce Axis";}
+  virtual StdString getName() {return "reduce_axis";}
 protected:
   
Index: /XIOS/trunk/src/transformation/axis_algorithm_reduce_domain.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_reduce_domain.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/axis_algorithm_reduce_domain.hpp	(revision 1982)
@@ -41,5 +41,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Axis Trans. Filter \\n Reduce Domain";}
+  virtual StdString getName() {return "reduce_domain";}
 
 protected:
Index: /XIOS/trunk/src/transformation/axis_algorithm_temporal_splitting.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_temporal_splitting.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/axis_algorithm_temporal_splitting.hpp	(revision 1982)
@@ -34,5 +34,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Axis Trans. Filter \\n Temporal Splitting";}
+  virtual StdString getName() {return "temporal_splitting";}
 
 protected:
Index: /XIOS/trunk/src/transformation/axis_algorithm_transformation.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_transformation.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/axis_algorithm_transformation.hpp	(revision 1982)
@@ -31,5 +31,5 @@
   virtual ~CAxisAlgorithmTransformation();
 
-  virtual StdString getName() {return "Axis Trans. Filter \\n Transformation";}
+  virtual StdString getName() {return "Axis Transformation";}
 
 protected:
Index: /XIOS/trunk/src/transformation/axis_algorithm_zoom.hpp
===================================================================
--- /XIOS/trunk/src/transformation/axis_algorithm_zoom.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/axis_algorithm_zoom.hpp	(revision 1982)
@@ -28,5 +28,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Axis Trans. Filter \\n Zoom";}
+  virtual StdString getName() {return "zoom_axis";}
 
 protected:
Index: /XIOS/trunk/src/transformation/domain_algorithm_compute_connectivity.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_compute_connectivity.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/domain_algorithm_compute_connectivity.hpp	(revision 1982)
@@ -29,5 +29,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Domain Trans. Filter \\n Compute Connectivity";}
+  virtual StdString getName() {return "compute_connectivity_domain";}
 
 protected:
Index: /XIOS/trunk/src/transformation/domain_algorithm_expand.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_expand.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/domain_algorithm_expand.hpp	(revision 1982)
@@ -29,5 +29,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Domain Trans. Filter \\n Expand";}
+  virtual StdString getName() {return "expand_domain";}
 
 protected:
Index: /XIOS/trunk/src/transformation/domain_algorithm_extract.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_extract.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/domain_algorithm_extract.hpp	(revision 1982)
@@ -24,5 +24,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Domain Trans. Filter \\n Extract";}
+  virtual StdString getName() {return "extract_domain";}
 protected:
   void updateDomainAttributes();
Index: /XIOS/trunk/src/transformation/domain_algorithm_generate_rectilinear.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_generate_rectilinear.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/domain_algorithm_generate_rectilinear.hpp	(revision 1982)
@@ -33,5 +33,5 @@
   virtual ~CDomainAlgorithmGenerateRectilinear() {}
 
-  virtual StdString getName() {return "Domain Trans. Filter \\n Generate Rectilinear";}
+  virtual StdString getName() {return "generate_rectilinear_domain";}
 
 protected:
Index: /XIOS/trunk/src/transformation/domain_algorithm_interpolate.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_interpolate.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/domain_algorithm_interpolate.hpp	(revision 1982)
@@ -40,5 +40,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Domain Trans. Filter \\n Interpolation";}
+  virtual StdString getName() {return "interpolate_domain";}
 
 protected:
Index: /XIOS/trunk/src/transformation/domain_algorithm_reorder.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_reorder.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/domain_algorithm_reorder.hpp	(revision 1982)
@@ -26,5 +26,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Domain Trans. Filter \\n Reorder";}
+  virtual StdString getName() {return "reorder_domain";}
 
 protected:
Index: /XIOS/trunk/src/transformation/domain_algorithm_transformation.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_transformation.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/domain_algorithm_transformation.hpp	(revision 1982)
@@ -27,5 +27,5 @@
   virtual ~CDomainAlgorithmTransformation();
 
-  virtual StdString getName() {return "Domain Trans. Filter \\n Transformation";}
+  virtual StdString getName() {return "Domain Transformation";}
 
 protected:
Index: /XIOS/trunk/src/transformation/domain_algorithm_zoom.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_zoom.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/domain_algorithm_zoom.hpp	(revision 1982)
@@ -24,5 +24,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Domain Trans. Filter \\n Zoom";}
+  virtual StdString getName() {return "zoom_domain";}
 protected:
   void updateDomainAttributes();
Index: /XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp
===================================================================
--- /XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp	(revision 1982)
@@ -74,5 +74,5 @@
                      bool ignoreMissingValue, bool firstPass);
 
-  virtual StdString getName() {return "Generic Trans. Filter";}
+  virtual StdString getName() {return "Generic Transformation";}
 
   /*!
Index: /XIOS/trunk/src/transformation/scalar_algorithm_extract_axis.hpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_extract_axis.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_extract_axis.hpp	(revision 1982)
@@ -39,5 +39,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Scalar Trans. Filter \\n Extract Axis";}
+  virtual StdString getName() {return "extract_axis";}
 
 protected:
Index: /XIOS/trunk/src/transformation/scalar_algorithm_reduce_axis.hpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_reduce_axis.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_reduce_axis.hpp	(revision 1982)
@@ -41,5 +41,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Scalar Trans. Filter \\n Reduce Axis";}
+  virtual StdString getName() {return "reduce_axis";}
 
 protected:
Index: /XIOS/trunk/src/transformation/scalar_algorithm_reduce_domain.hpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_reduce_domain.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_reduce_domain.hpp	(revision 1982)
@@ -41,5 +41,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Scalar Trans. Filter \\n Reduce Domain";}
+  virtual StdString getName() {return "reduce_domain";}
 
 protected:
Index: /XIOS/trunk/src/transformation/scalar_algorithm_reduce_scalar.hpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_reduce_scalar.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_reduce_scalar.hpp	(revision 1982)
@@ -36,5 +36,5 @@
   static bool registerTrans();
 
-  virtual StdString getName() {return "Scalar Trans. Filter \\n Reduce Scalar";}
+  virtual StdString getName() {return "reduce_scalar";}
 
 protected:
Index: /XIOS/trunk/src/transformation/scalar_algorithm_transformation.hpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_transformation.hpp	(revision 1981)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_transformation.hpp	(revision 1982)
@@ -31,5 +31,5 @@
   virtual ~CScalarAlgorithmTransformation();
 
-  virtual StdString getName() {return "Scalar Trans. Filter \\n Transformation";}
+  virtual StdString getName() {return "Scalar Transformation";}
 
 protected: