Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp	(revision 2195)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp	(revision 2196)
@@ -53,5 +53,5 @@
      m["temporal_splitting"] = TRANS_TEMPORAL_SPLITTING;
      m["duplicate_scalar"] = TRANS_DUPLICATE_SCALAR_TO_AXIS;
-
+     return true;
    }
    CATCH
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/compute_connectivity_domain.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/compute_connectivity_domain.cpp	(revision 2195)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/compute_connectivity_domain.cpp	(revision 2196)
@@ -28,5 +28,5 @@
   bool CComputeConnectivityDomain::registerTrans()
   {
-    registerTransformation(TRANS_COMPUTE_CONNECTIVITY_DOMAIN, {create, getTransformation});
+    return registerTransformation(TRANS_COMPUTE_CONNECTIVITY_DOMAIN, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp	(revision 2195)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp	(revision 2196)
@@ -2196,4 +2196,5 @@
     m["reorder_domain"] = TRANS_REORDER_DOMAIN;
     m["extract_domain"] = TRANS_EXTRACT_DOMAIN;
+    return true;
   }
   CATCH
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/expand_domain.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/expand_domain.cpp	(revision 2195)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/expand_domain.cpp	(revision 2196)
@@ -28,5 +28,5 @@
   bool CExpandDomain::registerTrans()
   {
-    registerTransformation(TRANS_EXPAND_DOMAIN, {create, getTransformation});
+    return registerTransformation(TRANS_EXPAND_DOMAIN, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/extract_domain.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/extract_domain.cpp	(revision 2195)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/extract_domain.cpp	(revision 2196)
@@ -28,5 +28,5 @@
   bool CExtractDomain::registerTrans()
   {
-    registerTransformation(TRANS_EXTRACT_DOMAIN, {create, getTransformation});
+    return registerTransformation(TRANS_EXTRACT_DOMAIN, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/generate_rectilinear_domain.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/generate_rectilinear_domain.cpp	(revision 2195)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/generate_rectilinear_domain.cpp	(revision 2196)
@@ -28,5 +28,5 @@
   bool CGenerateRectilinearDomain::registerTrans()
   {
-    registerTransformation(TRANS_GENERATE_RECTILINEAR_DOMAIN, {create, getTransformation});
+    return registerTransformation(TRANS_GENERATE_RECTILINEAR_DOMAIN, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_domain.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_domain.cpp	(revision 2195)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_domain.cpp	(revision 2196)
@@ -28,5 +28,5 @@
   bool CInterpolateDomain::registerTrans()
   {
-    registerTransformation(TRANS_INTERPOLATE_DOMAIN, {create, getTransformation});
+    return registerTransformation(TRANS_INTERPOLATE_DOMAIN, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reorder_domain.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reorder_domain.cpp	(revision 2195)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reorder_domain.cpp	(revision 2196)
@@ -28,5 +28,5 @@
   bool CReorderDomain::registerTrans()
   {
-    registerTransformation(TRANS_REORDER_DOMAIN, {create, getTransformation});
+    return registerTransformation(TRANS_REORDER_DOMAIN, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.cpp	(revision 2195)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/scalar.cpp	(revision 2196)
@@ -37,4 +37,5 @@
     m["reduce_domain"] = TRANS_REDUCE_DOMAIN_TO_SCALAR;
     m["reduce_scalar"] = TRANS_REDUCE_SCALAR_TO_SCALAR;
+    return true;
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/zoom_domain.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/zoom_domain.cpp	(revision 2195)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/zoom_domain.cpp	(revision 2196)
@@ -28,5 +28,5 @@
   bool CZoomDomain::registerTrans()
   {
-    registerTransformation(TRANS_ZOOM_DOMAIN, {create, getTransformation});
+    return registerTransformation(TRANS_ZOOM_DOMAIN, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/Functions/reduction.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/Functions/reduction.cpp	(revision 2195)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/Functions/reduction.cpp	(revision 2196)
@@ -27,4 +27,5 @@
   m["average"] = TRANS_REDUCE_AVERAGE;
   CAverageReductionAlgorithm::registerTrans();
+  return true;
 }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/axis_algorithm/axis_algorithm_interpolate.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/axis_algorithm/axis_algorithm_interpolate.cpp	(revision 2195)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/axis_algorithm/axis_algorithm_interpolate.cpp	(revision 2196)
@@ -48,4 +48,5 @@
   /// descativate for now
   // return CGridTransformationFactory<CAxis>::registerTransformation(TRANS_INTERPOLATE_AXIS, create);
+  return false;
 }
 CATCH